summaryrefslogtreecommitdiffstats
path: root/system/nvidia-legacy470-kernel
diff options
context:
space:
mode:
Diffstat (limited to 'system/nvidia-legacy470-kernel')
-rw-r--r--system/nvidia-legacy470-kernel/README20
-rw-r--r--system/nvidia-legacy470-kernel/doinst.sh3
-rw-r--r--system/nvidia-legacy470-kernel/nvidia-470.239.06-gcc14.patch29
-rw-r--r--system/nvidia-legacy470-kernel/nvidia-legacy470-kernel.SlackBuild120
-rw-r--r--system/nvidia-legacy470-kernel/nvidia-legacy470-kernel.info10
-rw-r--r--system/nvidia-legacy470-kernel/slack-desc19
6 files changed, 201 insertions, 0 deletions
diff --git a/system/nvidia-legacy470-kernel/README b/system/nvidia-legacy470-kernel/README
new file mode 100644
index 0000000000..7793219958
--- /dev/null
+++ b/system/nvidia-legacy470-kernel/README
@@ -0,0 +1,20 @@
+This is the kernel-module needed by the proprietary binary nvidia
+driver. You also need the nvidia-driver package from SlackBuilds.org.
+
+To build the package for a kernel different from the running one,
+start the script setting the KERNEL variable as in
+ KERNEL=4.6.3 ./nvidia-legacy470-kernel.SlackBuild
+
+A default config file is placed at
+ /usr/share/X11/xorg.conf.d/10-nvidia.conf
+to make sure that X loads the nvidia module. If you need to make
+changes, move that file to /etc/X11/xorg.conf.d/ and edit the copy.
+You do not need this file at all if you have a proper and complete
+xorg.conf.
+
+The xf86-video-nouveau-blacklist package from /extra is required.
+
+The Nvidia 470.xx series will be supported through December 2024.
+
+NOTE: To build in -current with gcc14 against the new 6.9.x kernel,
+pass "CURRENT=yes" to the script.
diff --git a/system/nvidia-legacy470-kernel/doinst.sh b/system/nvidia-legacy470-kernel/doinst.sh
new file mode 100644
index 0000000000..dcfb80855f
--- /dev/null
+++ b/system/nvidia-legacy470-kernel/doinst.sh
@@ -0,0 +1,3 @@
+
+chroot . /sbin/depmod -a @KERNEL@ 2>/dev/null
+
diff --git a/system/nvidia-legacy470-kernel/nvidia-470.239.06-gcc14.patch b/system/nvidia-legacy470-kernel/nvidia-470.239.06-gcc14.patch
new file mode 100644
index 0000000000..772236e5cf
--- /dev/null
+++ b/system/nvidia-legacy470-kernel/nvidia-470.239.06-gcc14.patch
@@ -0,0 +1,29 @@
+diff --git a/conftest.sh b/conftest.sh
+index 6e6da83..678b79c 100755
+--- a/conftest.sh
++++ b/conftest.sh
+@@ -101,7 +101,8 @@ test_header_presence() {
+ build_cflags() {
+ BASE_CFLAGS="-O2 -D__KERNEL__ \
+ -DKBUILD_BASENAME=\"#conftest$$\" -DKBUILD_MODNAME=\"#conftest$$\" \
+--nostdinc -isystem $ISYSTEM"
++-nostdinc -isystem $ISYSTEM -fshort-wchar \
++-Wno-implicit-function-declaration -Wno-strict-prototypes"
+
+ if [ "$OUTPUT" != "$SOURCES" ]; then
+ OUTPUT_CFLAGS="-I$OUTPUT/include2 -I$OUTPUT/include"
+@@ -4592,8 +4592,13 @@ compile_test() {
+ #
+ CODE="
+ #include <drm/drm_gem.h>
++ #if defined(NV_LINUX_IOSYS_MAP_H_PRESENT)
++ typedef struct iosys_map nv_sysio_map_t;
++ #else
++ typedef struct dma_buf_map nv_sysio_map_t;
++ #endif
+ int conftest_drm_gem_object_vmap_has_map_arg(
+- struct drm_gem_object *obj, struct dma_buf_map *map) {
++ struct drm_gem_object *obj, nv_sysio_map_t *map) {
+ return obj->funcs->vmap(obj, map);
+ }"
+
diff --git a/system/nvidia-legacy470-kernel/nvidia-legacy470-kernel.SlackBuild b/system/nvidia-legacy470-kernel/nvidia-legacy470-kernel.SlackBuild
new file mode 100644
index 0000000000..22d852dbcd
--- /dev/null
+++ b/system/nvidia-legacy470-kernel/nvidia-legacy470-kernel.SlackBuild
@@ -0,0 +1,120 @@
+#!/bin/bash
+
+# Slackware build script for nvidia-legacy470-kernel
+
+# Copyright 2007-2011 Heinz Wiesinger, Amsterdam, The Netherlands
+# Copyright 2012-2019 Edward W. Koenig, Vancouver, WA, USA
+# Updates cpyright 2021 Lenard Spencer, Orlando, FL, USA
+# All rights reserved.
+#
+# Redistribution and use of this script, with or without modification, is
+# permitted provided that the following conditions are met:
+#
+# 1. Redistributions of this script must retain the above copyright
+# notice, this list of conditions and the following disclaimer.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR ''AS IS'' AND ANY EXPRESS OR IMPLIED
+# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
+# EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
+# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
+# OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
+# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
+# OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
+# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+# Thanks to Robby Workman for suggestions to improve this script.
+
+# see nvidia-driver/changelog.txt
+
+cd $(dirname $0) ; CWD=$(pwd)
+
+PRGNAM=nvidia-legacy470-kernel
+VERSION=${VERSION:-470.239.06}
+BUILD=${BUILD:-2}
+TAG=${TAG:-_SBo}
+PKGTYPE=${PKGTYPE:-tgz}
+
+KERNEL=${KERNEL:-$(uname -r)}
+KERNELPATH=${KERNELPATH:-/lib/modules/${KERNEL}/build}
+
+set -e
+
+PKGVER=${VERSION}_$(echo $KERNEL | tr - _)
+
+if [ -z "$ARCH" ]; then
+ case "$( uname -m )" in
+ i?86) ARCH=i586 ;;
+ arm*) ARCH=arm ;;
+ *) ARCH=$( uname -m ) ;;
+ esac
+fi
+
+if [ "$ARCH" = "x86_64" ]; then
+ TARGET="x86_64"
+else
+ echo "$ARCH is not supported."
+ exit 1
+fi
+
+# If the variable PRINT_PACKAGE_NAME is set, then this script will report what
+# the name of the created package would be, and then exit. This information
+# could be useful to other scripts.
+if [ ! -z "${PRINT_PACKAGE_NAME}" ]; then
+ echo "$PRGNAM-$PKGVER-$ARCH-$BUILD$TAG.$PKGTYPE"
+ exit 0
+fi
+
+SRCNAM=NVIDIA-Linux-$TARGET-${VERSION}
+
+TMP=${TMP:-/tmp/SBo}
+PKG=$TMP/package-$PRGNAM
+OUTPUT=${OUTPUT:-/tmp}
+
+rm -rf $PKG
+mkdir -p $TMP $PKG $OUTPUT
+cd $TMP || exit 1
+rm -rf $SRCNAM
+sh $CWD/$SRCNAM.run --extract-only || exit 1
+cd $SRCNAM || exit 1
+chown -R root:root .
+find -L . \
+ \( -perm 777 -o -perm 775 -o -perm 750 -o -perm 711 -o -perm 555 \
+ -o -perm 511 \) -exec chmod 755 {} \; -o \
+ \( -perm 666 -o -perm 664 -o -perm 640 -o -perm 600 -o -perm 444 \
+ -o -perm 440 -o -perm 400 \) -exec chmod 644 {} \;
+
+(cd kernel || exit 1
+
+ unset ARCH
+
+# Patch for gcc-14 in current:
+if [ "${CURRENT:-no}" = "yes" ]; then
+ patch -p1 < $CWD/nvidia-470.239.06-gcc14.patch
+fi
+
+# CC=${CC:-gcc} suppresses an otherwise harmless "compiler mismatch"
+# message. If you custom-build your kernel with clang,
+# then pass CC=clang to this script.
+ CC=${CC:-gcc} make SYSSRC=$KERNELPATH module || exit 1
+)
+
+mkdir -p $PKG/lib/modules/$KERNEL/kernel/drivers/video
+install -m 0664 kernel/nvidia.ko $PKG/lib/modules/$KERNEL/kernel/drivers/video/
+install -m 0664 kernel/nvidia-modeset.ko $PKG/lib/modules/$KERNEL/kernel/drivers/video/
+install -m 0664 kernel/nvidia-drm.ko $PKG/lib/modules/$KERNEL/kernel/drivers/video/
+install -m 0664 kernel/nvidia-uvm.ko $PKG/lib/modules/$KERNEL/kernel/drivers/video/
+
+mkdir -p $PKG/usr/share/X11/xorg.conf.d/
+cat $TMP/$SRCNAM/nvidia-drm-outputclass.conf > $PKG/usr/share/X11/xorg.conf.d/10-nvidia.conf
+
+mkdir -p $PKG/usr/doc/$PRGNAM-$PKGVER
+cat $CWD/$PRGNAM.SlackBuild > $PKG/usr/doc/$PRGNAM-$PKGVER/$PRGNAM.SlackBuild
+
+mkdir -p $PKG/install
+cat $CWD/slack-desc > $PKG/install/slack-desc
+sed "s%@KERNEL@%$KERNEL%" $CWD/doinst.sh > $PKG/install/doinst.sh
+
+cd $PKG
+/sbin/makepkg -l y -c n $OUTPUT/$PRGNAM-$PKGVER-$ARCH-$BUILD$TAG.$PKGTYPE
diff --git a/system/nvidia-legacy470-kernel/nvidia-legacy470-kernel.info b/system/nvidia-legacy470-kernel/nvidia-legacy470-kernel.info
new file mode 100644
index 0000000000..7bde5b3a4b
--- /dev/null
+++ b/system/nvidia-legacy470-kernel/nvidia-legacy470-kernel.info
@@ -0,0 +1,10 @@
+PRGNAM="nvidia-legacy470-kernel"
+VERSION="470.239.06"
+HOMEPAGE="https://www.nvidia.com"
+DOWNLOAD="UNSUPPORTED"
+MD5SUM=""
+DOWNLOAD_x86_64="https://download.nvidia.com/XFree86/Linux-x86_64/470.239.06/NVIDIA-Linux-x86_64-470.239.06.run"
+MD5SUM_x86_64="4d007f78ef892929399aaf02152f4c38"
+REQUIRES=""
+MAINTAINER="Lenard Spencer"
+EMAIL="lenardrspencer@gmail.com"
diff --git a/system/nvidia-legacy470-kernel/slack-desc b/system/nvidia-legacy470-kernel/slack-desc
new file mode 100644
index 0000000000..c32b121efa
--- /dev/null
+++ b/system/nvidia-legacy470-kernel/slack-desc
@@ -0,0 +1,19 @@
+# HOW TO EDIT THIS FILE:
+# The "handy ruler" below makes it easier to edit a package description.
+# Line up the first '|' above the ':' following the base package name, and
+# the '|' on the right side marks the last column you can put a character in.
+# You must make exactly 11 lines for the formatting to be correct. It's also
+# customary to leave one space after the ':' except on otherwise blank lines.
+
+ |-----handy-ruler------------------------------------------------------|
+nvidia-legacy470-kernel: nvidia-legacy470-kernel (kernel interface for the Nvidia 470 driver)
+nvidia-legacy470-kernel:
+nvidia-legacy470-kernel: This is the kernel module needed by nvidia-legacy470-driver.
+nvidia-legacy470-kernel:
+nvidia-legacy470-kernel:
+nvidia-legacy470-kernel:
+nvidia-legacy470-kernel:
+nvidia-legacy470-kernel:
+nvidia-legacy470-kernel:
+nvidia-legacy470-kernel:
+nvidia-legacy470-kernel: